#ifndef DATA_H
#define DATA_H

#include "common.h"
#include "math.h"

void storedata (state_t * state, int xbin, int ybin, int valueidx,
		double value);

void storedata_n (state_t * state, int xbin, int ybin, int startidx,
		  int numvals, double *values);

static inline double
getdata (state_t * state, int xbin, int ybin, int valueidx)
{
  // Assume used_min/max are always kept accurate
  if (xbin < state->data_xused_min || xbin > state->data_xused_max ||
      ybin < state->data_yused_min || ybin > state->data_yused_max)
    return NAN;

  return state->data[((ybin + state->data_yzerooffset) * state->data_xsize
		      + (xbin + state->data_xzerooffset))
		     * state->data_valuesperbin + valueidx];
}

#endif /* DATA_H */
