#!/bin/sh

set -e

one_test () {
# $1 = name

  if [ -r "$1".json ] && [ -r "$1".data ] && [ -r "$1".csv ] ; then
    : # okay
  else
    echo "File(s) missing for $1" 1>&2
    exit 1
  fi

  echo "Starting test $1"

  ../../collect2d --topicprefix scwips-test --config ./"$1".json &

  ../../../render2d/render2d --topicprefix scwips-test --name r0 \
	--pubdir /tmp/scwips-test --pubpfx file:///tmp/scwips-test/ \
	-- scwips-test/collect/+/bindata  &

  sleep 1  # allow connecting to broker

  mosquitto_pub -t scwips-test/data -l < "$1".data

  mosquitto_pub -t scwips-test/cmd -m '{"cmd": "postdata"}'
  sleep 1  # allow creating pictures
  mosquitto_pub -t scwips-test/cmd -m '{"cmd": "shutdown"}'
  # wait for disconnection: below

  mv /tmp/scwips-test/xy_z_csv-r0.csv /tmp/scwips-test/"$1".csv
  mv /tmp/scwips-test/xy_z_tile-r0.png /tmp/scwips-test/"$1".png

  # compare against reference
  if diff -q /tmp/scwips-test/"$1".csv ./"$1".csv ; then
    echo "  is okay"
  else
    echo "  is FAILED"
  fi

  wait
}


mkdir -p /tmp/scwips-test


for CONFIG in *.json ; do
  one_test "${CONFIG%.json}"
done
