#!/bin/sh

# Linear walk resembling real-world positioning stream

# LIMITDEMO=1 to stop after defined length

BASEX=-100  # factor 10 for integer shell arith
BASEY=-100
DIRECTION=2

R=0

od -tu4 -An -w8 /dev/urandom |
  while read OFFSETX OFFSETY ; do

    BASEX="$(( $BASEX + $DIRECTION ))"
    if [ "$DIRECTION" -gt 0 ] && [ "$BASEX" -gt 100 ] ; then
      BASEY="$(( $BASEY + 10 ))"
      DIRECTION=-2
    elif [ "$DIRECTION" -lt 0 ] && [ "$BASEX" -lt -100 ] ; then
      BASEY="$(( $BASEY + 10 ))"
      DIRECTION=2
    fi

    [ -n "$LIMITDEMO" ] && [ "$BASEY" -gt 0 ] && break

    echo "
	  x = $BASEX / 10 + 0.25 * $OFFSETX / 2^32 ;
	  y = $BASEY / 10 + 0.25 * $OFFSETY / 2^32 ;
	  z = 10 * s(x) * s(y) ;
	 "'print x, " ", y, " ", z, "\n"'

  done |
  bc -l |
  while read X Y Z ; do
    # printf also conveniently outputs -.1 as json-compliant -0.1
    printf '{"x": %f, "y": %f, "z": %f}\n' "$X" "$Y" "$Z"
    sleep 0.1

    R="$(( $R + 1 ))"
    if [ "$R" -gt 30 ] ; then
      mosquitto_pub -t scwips/collect/cmd -m '{"cmd": "postdata"}'
      R=0
    fi
  done |
  mosquitto_pub -t scwips/objtrack/result -l
