#!/bin/sh

# Spiral walk resembling real-world positioning stream

# LIMITDEMO=1 to stop after defined length

T=0
R=0

od -tu4 -An -w8 /dev/urandom |
  while read OFFSETX OFFSETY ; do

    T="$(( $T + 1 ))"

    [ -n "$LIMITDEMO" ] && [ "$T" -gt 556 ] && break

    # spiral with constant linear speed:
    # https://gamedev.stackexchange.com/questions/16745

    echo "
	  r = sqrt( 3.0 * $T ) ;
	  x = -c(r) * r * 0.2 + 0.25 * $OFFSETX / 2^32 ;
	  y =  s(r) * r * 0.2 + 0.25 * $OFFSETY / 2^32 ;
	  z = 10 * s(x) * s(y) ;
	 "'print x, " ", y, " ", z, "\n"'

  done |
  bc -l |
  while read X Y Z ; do
    # printf also conveniently outputs -.1 as json-compliant -0.1
    printf '{"x": %f, "y": %f, "z": %f}\n' "$X" "$Y" "$Z"
    sleep 0.1

    R="$(( $R + 1 ))"
    if [ "$R" -gt 30 ] ; then
      mosquitto_pub -t scwips/collect/cmd -m '{"cmd": "postdata"}'
      R=0
    fi
  done |
  mosquitto_pub -t scwips/objtrack/result -l
