#!/bin/sh

set -e

one_test () {
# $1 = test number

  echo "Starting test $1"

  ../../collect2d --topicprefix scwips-test --config ./config.json \
	--interpolate-debug "$1"  &

  ../../../render2d/render2d --topicprefix scwips-test --name r0 \
	--pubdir /tmp/scwips-test --pubpfx file:///tmp/scwips-test/ \
	-- scwips-test/collect/+/bindata  &

  sleep 1  # allow connecting to broker

  # outer span
  mosquitto_pub -t scwips-test/data -m '{"x": 0.0, "y": 0.0, "z": 0.0}'
  mosquitto_pub -t scwips-test/data -m '{"x": 3.0, "y": 3.0, "z": 0.0}'

  # real data
  mosquitto_pub -t scwips-test/data -m '{"x": 1.0, "y": 1.0, "z": 1.0}'
  mosquitto_pub -t scwips-test/data -m '{"x": 2.4, "y": 0.8, "z": 2.0}'
  mosquitto_pub -t scwips-test/data -m '{"x": 1.2, "y": 2.6, "z": 3.0}'
  mosquitto_pub -t scwips-test/data -m '{"x": 2.0, "y": 2.2, "z": 4.0}'

  mosquitto_pub -t scwips-test/cmd -m '{"cmd": "postdata"}'
  sleep 1  # allow creating pictures
  mosquitto_pub -t scwips-test/cmd -m '{"cmd": "shutdown"}'
  # wait for disconnection: below

  mv /tmp/scwips-test/xy_z_csv-r0.csv /tmp/scwips-test/interp-"$1".csv
  mv /tmp/scwips-test/xy_z_tile-r0.png /tmp/scwips-test/interp-"$1".png

  # compare against reference
  if diff -q /tmp/scwips-test/interp-"$1".csv ./interp-"$1".csv ; then
    echo "  is okay"
  else
    echo "  is FAILED"
  fi

  wait
}


mkdir -p /tmp/scwips-test


for SERIES in 16 64 ; do
  for DIRECTION in 0 1 2 3 4 5 6 7 ; do
    one_test "$(( $SERIES + $DIRECTION ))"
  done
done
