#ifndef COMMON_H
#define COMMON_H

#include <unistd.h>
#include <time.h>
#include <mosquitto.h>
#include "../shared/mqttpub.h"

#define FNAMELEN   10000

#define DEBUG

#ifdef DEBUG
#define MDBG(format, args...)  \
    mqttprintf(state->mosq,  \
	state->topicprefix, "imgproc", state->name, "debug", NULL,  \
	"%s %d %s:%d %s(): " format ,  \
	progname, getpid(), __FILE__, __LINE__, __func__, ##args)
#else
#define MDBG(format, args...)  do { } while(0)
#endif

typedef struct
{
  struct mosquitto *mosq;

  char *svr_hostname;
  int svr_port;
  int connstate;
  time_t connect_nexttime;	/* Planned time of next connect attempt;
				   also stdin-EOF force-disconnect time */
  char *topicprefix;
  char *name;
  char name_sane[TOPICLEN + 5];
  char *imgpubdir;
  char *imgpubpfx;
  char **recv_topics;
  int recv_topics_num;

  char broadcmd_topic[TOPICLEN + 5];
  char imgproccmd_topic[TOPICLEN + 5];
  char ourcmd_topic[TOPICLEN + 5];

  int overactive_counter;
  int idletimer_fd;
  int idletimer_running;
} state_t;

extern const char *progname;

#endif // COMMON_H
