#ifndef STATE_H
#define STATE_H

#include <unistd.h>
#include <mosquitto.h>
#include "../shared/mqttpub.h"

#define DEBUG

#ifdef DEBUG
#define MDBG(format, args...)  \
    mqttprintf(state->mosq,  \
	state->topicprefix, "objtrack/debug", NULL,  \
	"%s %d %s:%d %s(): " format ,  \
	progname, getpid(), __FILE__, __LINE__, __func__, ##args)
#else
#define MDBG(format, args...)  do { } while(0)
#endif


typedef struct
{
  struct mosquitto *mosq;

  char *svr_hostname;
  int svr_port;
  char *topicprefix;

  int connstate;
  time_t connect_nexttime;	/* Planned time of next connect attempt;
				   also shutdown force-disconnect time */

  char broadcmd_topic[TOPICLEN + 5];
  char objtrackcmd_topic[TOPICLEN + 5];
  char sceneresult_topic[TOPICLEN + 5];
  char caminfo_topic[TOPICLEN + 5];
  char campix_topic[TOPICLEN + 5];
  char cam_topicmatch[TOPICLEN + 5];
  int cam_topicmatchlen;

  int sceneokay;
  int fixreported;

  struct itimerspec zero_itimval;
  struct itimerspec pixinval_itimval;
  struct itimerspec morepixwait_itimval;
  struct itimerspec fixlost_itimval;

  int morepixwait_timerfd;
  int morepixwait_running;
  int fixlost_timerfd;
} state_t;

extern state_t *state;

#endif /* STATE_H */
