// Part of SCWIPS  Copyright (C) 2021 J.A.Bezemer@opensourcepartners.nl  GPL>=3

#include <sys/timerfd.h>
#include <jansson.h>

#include "idletimer.h"
#include "../shared/mqttpub.h"

void
idletimer_start (state_t * state)
{
  if (!state->idletimer_running)
    {
      struct itimerspec itimer;

      itimer.it_value.tv_sec = 0;
      itimer.it_value.tv_nsec = 100000000;
      itimer.it_interval.tv_sec = 0;
      itimer.it_interval.tv_nsec = 0;

      timerfd_settime (state->idletimer_fd, 0, &itimer, NULL);

      state->idletimer_running = 1;
    }
}

void
idletimer_stop (state_t * state)
{
  if (state->idletimer_running)
    {
      struct itimerspec itimer;

      itimer.it_value.tv_sec = 0;
      itimer.it_value.tv_nsec = 0;
      itimer.it_interval.tv_sec = 0;
      itimer.it_interval.tv_nsec = 0;

      // _settime will drop pending triggers, no need to read()
      timerfd_settime (state->idletimer_fd, 0, &itimer, NULL);

      state->idletimer_running = 0;
    }
}

void
idletimer_expired (state_t * state)
{
  idletimer_stop (state);

  if (state->connstate != CS_CONNECTED)
    return;			// Nobody is listening

  mqttpubjson (state->mosq, state->topicprefix, "render", state->name,
	       "status", NULL, json_pack ("{s:s}", "state", "idle"));
}
