#!/bin/sh

set -e

echo "Starting test"

mkdir -p /tmp/scwips-test

../render2d --topicprefix scwips-test --name r0 \
	--pubdir /tmp/scwips-test --pubpfx file:///tmp/scwips-test/ \
	-- scwips/collect/+/bindata  &
sleep 1  # allow connecting


one_test () {
  echo "$1"

  ../../mqttlogger/repost/repost-all < "$1".mqtt  >/dev/null
  sleep 1  # allow rendering

  mv /tmp/scwips-test/xy-z-csv-r0.csv /tmp/scwips-test/"$1".csv
  mv /tmp/scwips-test/xy-z-tile-r0.png /tmp/scwips-test/"$1".png

  if diff -q /tmp/scwips-test/"$1".csv ./"$1".csv ; then
    echo "  is okay"
  else
    echo "  is FAILED"
  fi
}

one_test test1a
one_test test1b
one_test test1c
one_test test1d

one_test test2a
one_test test2b
one_test test2c
one_test test2d

mosquitto_pub -t scwips-test/cmd -m '{"cmd": "shutdown"}'
