#ifndef STATE_H
#define STATE_H

#include <unistd.h>
#include <mosquitto.h>
#include "../shared/mqttpub.h"

#define DEBUG

#ifdef DEBUG
#define MDBG(format, args...)  \
    mqttprintf(state->mosq,  \
	state->topicprefix, "scene", state->name, "debug", NULL,  \
	"%s %d %s:%d %s(): " format ,  \
	progname, getpid(), __FILE__, __LINE__, __func__, ##args)
#else
#define MDBG(format, args...)  do { } while(0)
#endif


typedef struct
{
  struct mosquitto *mosq;

  char *svr_hostname;
  int svr_port;
  char *topicprefix;
  char *name;

  int connstate;
  time_t connect_nexttime;	/* Planned time of next connect attempt;
				   also shutdown force-disconnect time */

  char broadcmd_topic[TOPICLEN + 5];
  char scenecmd_topic[TOPICLEN + 5];
  char ourcmd_topic[TOPICLEN + 5];
  char sceneobs_topic[TOPICLEN + 5];
  char caminfo_topic[TOPICLEN + 5];
  char cam_topicmatch[TOPICLEN + 5];
  int cam_topicmatchlen;

  int random_inited;
  int calculating;
  int calc_full_restart;
  int calc_had_fix_previously;
  int attempts;
  int resultokay;
  double res_maxsumsq;
  double res_sumsq;
  int res_rounds;
} state_t;

extern state_t *state;

#endif /* STATE_H */
