#ifndef HAVE_ERRORS_H
#define HAVE_ERRORS_H

extern const char *progname;


// Note that C99 has new ... with __VA_ARGS__

#define STDERR(format, args...)					\
  fprintf(stderr, "%s error at %s:%d %s(): " format "\n",	\
	progname, __FILE__, __LINE__, __func__, ##args)


#define CMDLINEERR_RETURN2(format, args...)			\
  do {								\
    fprintf(stderr, "%s error: " format "\n"			\
	"Usage info:  %s --help\n",				\
	progname, ##args , progname);				\
    return 2;							\
  } while(0)


#endif /* HAVE_ERRORS_H */
